\\ Copyright 2014, 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.

default(strictargs,1);

gf_terms(g,n) =
{
  my(x = variable(g),
     zeros = min(n,valuation(g,x)),
     v = Vec(g + O(x^n)));
  if(zeros>=0, concat(vector(zeros,i,0), v),
               v[-zeros+1 .. #v]);
}

poly8alt(x) = 1 - 2*x^2 - x^4 + 2*x^6 - 4*x^8;
poly9(x) = 1 - 3*x + 3*x^2 - 3*x^3 + 2*x^4 + 4*x^5 - 8*x^6 + 8*x^7 - 16*x^8 + 8*x^9;

gV2_a(x) = 1/2*1/(1-x);
gV2_b(x) = {
  +
    1/16442 * (
      -23610 - 21645*x + 15327*x^2 - 10878*x^3
      + 22506*x^4 + 41598*x^5 - 30864*x^6 - 78060*x^7)
    / poly8alt(x);
}
gV2_c(x) = {
  +
    1/16442 * (
      15389 - 32743*x + 29567*x^2 - 30964*x^3 - 3208*x^4
      + 65384*x^5 - 60412*x^6 + 118976*x^7 - 156120*x^8)
    / poly9(x)
;}
gV2(x) = gV2_a(x) + gV2_b(x) + gV2_c(x);

gf_terms(gV2_b(x),20)
gf_terms(gV2_c(x),20)
