\\ Copyright 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


read("pol-pfrac.gp");

\\ Strichartz and Wang
\\ polroots(p)
\\ vecsort(apply(abs,polroots(p)))
\\ vecsort(polroots(p),(a,b)->a=abs(a);b=abs(b);cmp(b,a))
\\ root 1.954776399102463907266
\\
sw_poly = x^9 - 3*x^8 + 3*x^7 - 3*x^6 + 2*x^5 + 4*x^4 - 8*x^3 + 8*x^2 - 16*x + 8;

\\ 11 -> 1 -> 3,3
\\         -> 7
\\     1  2  3  4  5
\\ 1      1     1
\\ 2
\\ 3         2
\\ 4
\\ 5
\\ 6   0  0  0  1
\\ 7         1
\\ 8
\\ 9            2
\\ 10           2
\\ 11  1  2        2

\\          *   k=1
\\          |
\\     *----*     11

\\     *<---*   k=2
\\          |
\\          *
\\          |
\\     *--->*     11, 1, 11  = 3 total

\\  k=3     11   1                         1 2of
\\         *---*---*  11
\\         |       |    7,3                3 2of
\\         *       *<---*
\\                      |     11,3         7 1of
\\                      *                 11 4of
\\                      |     1             ---
\\                 *--->*                    9
\\                   11

\\ k=4              11,9,1                        1  5of
\\        11,3  1        1,10                     3  4of
\\   7,3  *---*---* *---*---*  11
\\  11    |       | |       |    7,3              6  1of
\\    *---*   11,9 *  6     *<---*                7  2of
\\ 1  |        10                |     11,3       9  2of
\\    *                          *               10  2of
\\ 11 |                          |     1         11  8of
\\    *-->*                 *--->*                  ---
\\                           11                     24
\\ 5+4+1+2+2+2+8 == 24

m = m=matrix(11,11);
m[1,3] += 2; m[1,7]++;
m[2,3] += 2;
m[3,10]++;
m[4,7] += 2;
m[5,4]++; m[5,10] += 2;
m[6,11] += 2;
m[7,1]++; m[7,6]++; m[7,9]+=2;
m[8,5]++; m[8,8]++;
m[9,2]++; m[9,9]++;
m[10,8]++;
m[11,1]++;
\\ m[11,11] += 2;
\\ m[12,8]++;
\\ for(i=1,11, m[i,11] += 2);

\\ k=1  11->1
\\ k=2  1 -> 3,3,7
\\ k=3  3->10  7 -> 1,6,9,9
\\ 4 -> 7,7

{
  externstr("rm -f /tmp/single-double.matrix");
  my(str = "n=11\nm");
  for(i=1,11,
     for(j=1,11,
        my(bit = (m[i,j]||m[j,i])!=0); \\ i!=j && 
        str = concat(str, Str(bit)));
     str = concat(str,"\n"));
  write("/tmp/single-double.matrix",str);
  print(externstr("cat /tmp/single-double.matrix"));
  print(externstr("nauty-amtog /tmp/single-double.matrix")[1]);
  print(externstr("nauty-amtog -s /tmp/single-double.matrix")[1]);
}
{
  for(i=1,11,
     for(j=1,11,
        if(m[i,j],
           print("[",i-1,",",j-1,"],"))));
}
quit


\\ [  1   2   3   4   5   6   7   8   9  10  11]
\\ 
\\ [  0   0   0   0   0   0   0   0   0   0   1]
\\ [  1   0   0   0   0   0   0   0   0   0   0]
\\ [  0   0   2   0   0   0   1   0   0   0   0]
\\ 
\\ [  1   0   0   0   0   1   0   0   2   2   0]
\\ [  0   2   2   0   0   0   1   2   2   0   2]
\\ [  3   2   2   0   2   1   0   2   4   2   0]
\\ 
\\ [  0   4   8   2   2   0   3   4   4   6   2]
\\ [  5   4   4   2   4   3   4  10  10  12   0]
\\ [  4  10  14   4  10   4   9  22  18  12   6]
\\ 
\\ [ 15  18  18  10  22   9  12  34  36  34   8]
\\ [ 20  36  48  22  34  12  35  68  60  62  18]

\\          1    2    3    4    5    6    7    8    9   10   11
\\ k= 0     0    0    0    0    0    0    0    0    0    0    1    1
\\ k= 1     1    0    0    0    0    0    0    0    0    0    0    1
\\ k= 2     0    0    2    0    0    0    1    0    0    0    0    3

\\ k= 3     1    0    0    0    0    1    0    0    2    2    1    7
\\ k= 4     0    2    2    0    0    0    1    2    2    0    4   13
\\ k= 5     3    2    4    0    2    1    0    2    4    2    2   22

\\ k= 6     0    4   10    2    2    0    3    4    4    8    5   42
\\ k= 7     5    4    8    2    4    3    4   12   10   14    4   70
\\ k= 8     4   10   18    4   12    4    9   26   18   16   15  136


m=mattranspose(m);

m
matdet(m)
Mat(Col(mateigen(m,1)[1]))

\\ x*m*g = [1]
\\ g = 1 - x*m
initial = vectorv(11,i, i==11);
matsolve(x*m, initial)
mathnf(m,4)[1]


len=20;
r=matrix(len,11);
r[1,] = vector(11,i,i);
{
  my(v=initial);
  for(i=1,len-1,
     r[i+1,]=Vec(v);
     v=m*v;
     \\ v[11] += 1;
  );
}

r
r[,6]
print("column totals");
vector(len,i, vecsum(r[i,]))

\\ pairwise 1/2*2^k*(2^k-1)
\\ vector(len,i, 1/2*2^i*(2^i-1))





\\ calc
\\ 0, 0, 0, 1, 0, 1, 0, 3, 2, 7, 6, 25, 36, 81
\\
\\ [  1   2   3   4   5   6   7   8   9  10  11]
\\ 
\\ [  0   0   0   0   0   0   0   0   0   0   1]
\\ [  1   0   0   0   0   0   0   0   0   0   0]
\\ [  0   0   2   0   0   0   1   0   0   0   0]
\\ 
\\ [  1   0   0   0   0   1   0   0   2   2   0]
\\ [  0   2   2   0   0   0   1   2   2   0   2]
\\ [  3   2   4   0   2   1   0   2   4   2   0]
\\ 
\\ [  0   4  10   2   2   0   3   4   4   8   2]
\\ [  5   4   8   2   4   3   4  12  10  14   0]
\\ [  4  10  18   4  12   4   9  26  18  16   6]
\\ 
\\ [ 15  18  28  12  26   9  12  42  36  42   8]
\\ [ 20  36  66  26  42  12  39  84  60  80  18]
\\ [ 57  60 112  42  84  39  72 164 138 150  24]


\\ across next copy
\\ 0, 0, 0, 1, 0, 1, 0, 3, 4, 9, 12, 39, 72, 141, 264, 547, 036
\\
\\          1    2    3    4    5    6    7    8    9   10   11
\\
\\ k= 0     0    0    0    0    0    0    0    0    0    0    1    1
\\ k= 1     1    0    0    0    0    0    0    0    0    0    0    1
\\ k= 2     0    0    2    0    0    0    1    0    0    0    0    3
\\
\\ k= 3     1    0    0    0    0    1    0    0    2    2    0    6
\\ k= 4     0    2    2    0    0    0    1    2    2    0    2   11
\\ k= 5     3    2    4    0    2    1    0    2    4    2    0   20
\\
\\ k= 6     0    4   10    2    2    0    3    4    4    8    2   39
\\ k= 7     5    4    8    2    4    3    4   12   10   14    0   66
\\ k= 8     4   10   18    4   12    4    9   26   18   16    6  127
\\
\\ k= 9    15   18   28   12   26    9   12   42   36   42    8  248
\\ k=10    20   36   66   26   42   12   39   84   60   80   18  483
\\ k=11    57   60  112   42   84   39   72  164  138  150   24  942

d = [0, 0, 0, 1, 0, 1, 0, 3, 4, 9, 12, 39, 72, 141, 264, 547, 036];
powersof2(v) = vector(#v,i, sum(j=1,i, v[j]*2^(i-j)));
powersof2(d)
\\    0, 0, 0, 1, 2, 5, 10, 23, 50, 109, 230, 499, 1070, 2281, 4826, 10199, 20434

\\ 0, 0, 0, 0, 1, 2, 5, 10, 23, 50, 109, 230, 499
\\ 0, 0, 0, 0, 1, 2, 5, 10, 23, 50, 109, 230, 499, 1070, 2281,


gf_terms(g,n) = \
  my(x = variable(g), \
     zeros = min(n,valuation(g,x)), \
     v = Vec(g + O(x^n))); \
  if(zeros>=0, concat(vector(zeros,i,0), v), \
               v[-zeros+1 .. #v]);

S_samples = [ 1,2,4, 8,14,28, 54,108,210,  412, 806, 1588, 3098, 6052, 11822 ];
S(k) = if(k<9,return(S_samples[k+1])); \
       3*S(k-1) \
    -  3*S(k-2) \
    +  3*S(k-3) \
    -  2*S(k-4) \
    -  4*S(k-5) \
    +  8*S(k-6) \
    -  8*S(k-7) \
    + 16*S(k-8) \
    -  8*S(k-9);
D(k) = 1/2*(2^k-S(k));
poly9(x) = 1 - 3*x + 3*x^2 - 3*x^3 + 2*x^4 + 4*x^5 - 8*x^6 + 8*x^7 - 16*x^8 + 8*x^9;
gS(x) = (1 - x + x^2 - x^3 - 2*x^4 + 6*x^5 - 4*x^6 + 12*x^7 - 8*x^8)/poly9(x);
gD(x) = 1/2*(1/(1-2*x) - gS(x));
vector(20,k,D(k)-2*D(k-1))
\\ 0, 0, 0, 1, 0, 1, 0, 3, 4, 9, 12, 39, 72, 141, 264, 547, 1036, 2017, 3876, 7615

\\ gD(x) = 1/(1-2*x) * gDJ(x)
gDJ(x) = gD(x) -2*x*gD(x);
gf_terms(gDJ(x),20)
gDJ(x) == (x^4 - 3*x^5 + 4*x^6 - 6*x^7 + 8*x^8 - 4*x^9) \
   / (1 - 3*x + 3*x^2 - 3*x^3 + 2*x^4 + 4*x^5 - 8*x^6 + 8*x^7 - 16*x^8 + 8*x^9)

read("pol-ascend.gp");
pol_ascending_print(gDJ(x))
pol_ascending_print(pol_partial_fractions(gDJ(x)))

gDJ(x) == -1/2 \
 + (1/2 - 3/2*x + 3/2*x^2 - 3/2*x^3 + 2*x^4 - x^5 - 2*x^7) \
 / (1 - 3*x + 3*x^2 - 3*x^3 + 2*x^4 + 4*x^5 - 8*x^6 + 8*x^7 - 16*x^8 + 8*x^9)

gDJ(x) == 1/2* (-1 \
 + (1 - 3*x + 3*x^2 - 3*x^3 + 4*x^4 - 2*x^5         - 4*x^7) \
 / (1 - 3*x + 3*x^2 - 3*x^3 + 2*x^4 + 4*x^5 - 8*x^6 + 8*x^7 - 16*x^8 + 8*x^9) )

\\-----------------------------------------------------------------------------

cmp_by_abs_descending(a,b) = cmp(abs(b),abs(a));
polroots_descending(p) = vecsort(polroots(p),cmp_by_abs_descending);

read("../tools/memoize.gp");
DJ_samples = [ 0, 0, 0, 1, 0, 1, 0, 3, 4, 9, 12, 39, 72, 141, 264, 547, 1036 ];
DJ(k) = if(k<9,return(DJ_samples[k+1])); \
       3*DJ(k-1) \
    -  3*DJ(k-2) \
    +  3*DJ(k-3) \
    -  2*DJ(k-4) \
    -  4*DJ(k-5) \
    +  8*DJ(k-6) \
    -  8*DJ(k-7) \
    + 16*DJ(k-8) \
    -  8*DJ(k-9);
DJ = memoize(DJ);
\\ for(k=10,100,print(log(DJ(k)/DJ(k-1))))
\\ for(k=10,100,print(1.0*DJ(k)/DJ(k-1)))
my(v=polroots_descending(poly9(x))); for(i=1,#v, print(v[i]));

sw_poly(x) = x^9 - 3*x^8 + 3*x^7 - 3*x^6 + 2*x^5 + 4*x^4 - 8*x^3 + 8*x^2 - 16*x + 8;
print("sw");
my(v=polroots_descending(sw_poly(x))); for(i=1,#v, print(v[i]));


\\-----------------------------------------------------------------------------
